#include <stdio.h>
#include <stdlib.h>
#include <inttypes.h>
#include "utils.h"

bin_tree::~bin_tree() {
	if (this->bit_0) {
		delete this->bit_0;
	}
	if (this->bit_1) {
		delete this->bit_1;
	}
}

bin_tree::bin_tree() {
	this->bit_0=0;
	this->bit_1=0;
	this->data=-1;
}

bin_stream::bin_stream(FILE *f) {
	this->fp=f;
	this->data=0;
	this->bits=0;
}

void bin_stream::flush() {
	this->data=0;
	this->bits=0;
}

int bin_stream::peek() {
	if (this->bits==0) {
		this->bits=8;
		this->data=fgetc(this->fp);
		if (this->data==EOF) {
			this->bits=0;
		}
	}
	return this->data;
}

int bin_stream::read(int count) {
	uint32_t ret;
	int in;

	while (count>this->bits) {
		if ((in=fgetc(this->fp))==EOF) {
			this->bits=0;
			ret=this->data;
			this->data=0;
			return ret;
		}
		this->data=this->data|(in<<this->bits);
		this->bits=this->bits+8;

	}

	ret=this->data&((1<<count)-1);

	this->bits=this->bits-count;
	this->data=this->data>>count;

	return ret;
}

buffer::buffer() {
	this->pos=0;
}

buffer::~buffer() {
	this->flush();
}


void buffer::addbyte(int b) {
	this->data[this->pos++]=b;
	if (this->pos>=32768) {
		this->flush();
	}
}

int buffer::flush() {
	int i;

	for (i=0;i<this->pos;i++) {
		printf("%c",this->data[i]);
	}
	this->pos=0;

	return 0;
}

void buffer::copy(int len, int dist) {
	int source_index=this->pos-dist;

	if (source_index<0) {
		source_index=source_index+32768;
	}

	while(len--) {
		this->data[this->pos]=this->data[source_index];
		this->pos++;
		source_index++;
		if (source_index>=32768) {
			source_index=0;
		}
		if (this->pos>=32768) {
			this->flush();
		}
	}
}

